package hibintro.v1.model;

import javax.persistence.Entity;
import javax.persistence.Id;

/**
 * @author goik
 * 
 * A simple class intended to be mapped to a database server
 *
 */
@Entity
public class User {

  String uid;
  /**
   * 
   * @return  The user's unique login name e.g. "goik"
   */
  @Id
  public String getUid() {
    return uid;
  }
  /**
   * @param uid See {@link #getUid()}.
   */
  public void setUid(String uid) {
    this.uid = uid;
  }
  String cname;
  /**
   * @return The user's common name e.g. "Martin Goik"
   */
  public String getCname() {
    return cname;
  }
  /**
   * @param cname See {@link #getCname()}.
   */
  public void setCname(String cname) {
    this.cname = cname;
  }

  /**
   * Hibernate/JPA require a default constructor 
   */
  public User() {}

  /**
   * @param uid See {@link #getUid()}.
   * @param cname See {@link #getCname()}.
   */
  public User(String uid, String cname) {
    this.uid = uid;
    this.cname = cname;
  }
}