package inherit.v1;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;

@Entity
@DiscriminatorValue(value = "Credit card")
public class CreditCard extends BillingDetails {

   int cardType;
   /**
    * The card's company (e.g. Mastercard, Visa,...) represented by fixed integer values
    * @return 
    */
   public int getCardType() {return cardType;}
   public void setCardType(int cardType) {this.cardType = cardType;}
   
   Date expiration;
   public Date getExpiration() {return expiration;}
   public void setExpiration(Date expiration) {this.expiration = expiration;}
   /**
    * Convenience method on top of {@link #setExpiration(Date)}
    * 
    * @param expiration Expiration date provided as "MM/dd/yy"
    * @throws ParseException
    */
   public void setExpiration(String expiration) throws ParseException {
      setExpiration(new SimpleDateFormat("MM/dd/yy").parse(expiration));}
   public CreditCard(){super();}
   
   public CreditCard(final String creditCardNumber, final int cardType, final String expiration) throws ParseException {
      super(creditCardNumber);
      setCardType(cardType);
      setExpiration(expiration);
   }
}
